﻿Imports System.Collections.Specialized
Imports Infragistics.Win.DataVisualization

Public Class Form1

   Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

      Dim rand As New Random(DateTime.UtcNow.Millisecond)
      Dim col As New DataCollection
      col.Add(New DataPoint(#2/1/2023#, rand.NextDouble))
      col.Add(New DataPoint(#2/2/2023#, rand.NextDouble))
      col.Add(New DataPoint(#2/8/2023#, rand.NextDouble))

      Dim sharedXAxis As New TimeXAxis With {.LabelLocation = AxisLabelsLocation.OutsideBottom, .DataSource = col, .DateTimeMemberPath = "X"}
      sharedXAxis.LabelFormats.Add(New TimeAxisLabelFormat With {.Format = "HH:mm"})
      Me.UltraDataChart1.Axes.Add(sharedXAxis)

      Dim yAxis1 As New NumericYAxis With {.LabelLocation = AxisLabelsLocation.OutsideLeft, .MinimumValue = 0, .MaximumValue = 1}
      Me.UltraDataChart1.Axes.Add(yAxis1)

      Dim series1 As New LineSeries With {.DataSource = col, .ValueMemberPath = "Y", .XAxis = sharedXAxis, .YAxis = yAxis1}

      Me.UltraDataChart1.Series.Add(series1)

      'Adding an extra point to the collection causes an exception
      col.Add(New DataPoint(#2/9/2023#, rand.NextDouble))
   End Sub

End Class

Public Class DataCollection
   Implements INotifyCollectionChanged
   Implements IEnumerable

   Protected Data As New List(Of DataPoint)

   Public Event CollectionChanged As NotifyCollectionChangedEventHandler Implements INotifyCollectionChanged.CollectionChanged

   Protected Sub OnCollectionChanged(e As NotifyCollectionChangedEventArgs)
      RaiseEvent CollectionChanged(Me, e)
   End Sub

   Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
      Return Me.Data.GetEnumerator
   End Function

   Public Sub Add(dataPoint As DataPoint)
      Me.Data.Add(dataPoint)
      Me.OnCollectionChanged(New NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Add, dataPoint))
   End Sub

End Class

Public Class DataPoint

   Public ReadOnly Property X As DateTime

   Public ReadOnly Property Y As Double

   Public Sub New(x As DateTime, y As Double)
      Me.X = x
      Me.Y = y
   End Sub

End Class
